#!/usr/bin/perl
# CVS: @(#) $Id$

################################################################
# rss.cgi
#
# AUTHORS:
#	Copyright (C) 2006 Altinity Limited
#
#    This file is part of Opsview
#
#    Opsview is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Opsview is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Opsview; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
################################################################


use strict;
use CGI;
use CGI::Carp qw(fatalsToBrowser);

{ package Settings; do "/etc/nagios/rss.cfg" }

$CGI::DISABLE_UPLOADS = 1;
$CGI::POST_MAX = 102400;   # 100 Kb

my $q = CGI->new;

my $rssfile = "${Settings::rssdir}/$ENV{REMOTE_USER}.rss";

print $q->header( -type => "application/rss+xml" );

unless (-r $rssfile) {
	require XML::RSS;
	my $rss = new XML::RSS (version => "2.0");
	$rss->channel(title => "Opsview RSS Error");
	$rss->add_item( title => "RSS Error - contact administrator",
		link => $Settings::server,	# Required for Firefox
		description => "You are logged in as $ENV{REMOTE_USER} and do not have any RSS feeds defined - please speak to your Opsview administrator");
	print $rss->as_string;
	exit;
}

open RSS, $rssfile;
print <RSS>;
close RSS;
exit;

